import { world, system } from "@minecraft/server";

const helmetIds = new Array(3).fill(0).map((_, idx) => `mh:miner_helmet${idx + 1}`);

system.events.beforeWatchdogTerminate.subscribe(data => {
  data.cancel = true;
});

world.events.tick.subscribe(async (evt) => {
  if ((evt.currentTick % 5) != 0) return;

  for (const player of world.getPlayers()) {
    for (const helmetId of helmetIds) {
      const has = await hasItem(player, "slot.armor.head", helmetId);
      console.warn(has);

      if (has) {
        await player.runCommandAsync("function miner_candle_light");
        await player.runCommandAsync("particle heavy:simple_fire ~~2.2~");
      } else {
        await player.runCommandAsync("function miner_candle_no_light");
      }
    }
  }
});

async function hasItem(player, slot, itemId) {
  try {
    const results = await player.runCommandAsync(`testfor @s[hasitem={item=${itemId},location=${slot}}]`);
    return results.successCount > 0;
  } catch (e) {
    console.warn(e);
    return false;
  }
  return false;
}
